// TsDescrambler.h: CTsDescrambler NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSSERVICESELECT_H_)
#define _TSSERVICESELECT_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "IMediaDecoder.h"
#include "TsStream.h"
#include "TsTable.h"
#include "..\cusb2.h"

using std::vector;

#define	CMD_IR_CODE			0x5d	//val_l, val_h

/////////////////////////////////////////////////////////////////////////////
// wT[rXŎgpPID+EITTOTo
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		TSpPbg
// Output	#0	: CTsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

class CTsServiceSelect : public IMediaDecoder  
{
public:
	CTsServiceSelect();
	virtual ~CTsServiceSelect();

// IMediaDecoder
	virtual void Reset(void);

	virtual void SetServiceId(int ServiceId);
	virtual void SetSvcNo(int SvcNo);
	virtual int GetChChangeCount(void);
	virtual void SetUsb(cusb2* usbpoint,CCyUSBEndPoint* outp,u16* pCmd,s32 num,u16 base) {
		m_usb = usbpoint;
		m_outep = outp;
		memcpy(m_ir_cmd,pCmd,num*sizeof(u16));
		m_ir_cmd_num = num;
		m_ir_base = base;
	};

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);

	const DWORD GetInputPacketCount(void) const;
	const DWORD GetOutputPacketCount(void) const;

protected:
	const bool ProcPatPacket(const CTsPacket *pTsPacket);
	const bool ProcPmtPacket(const CTsPacket *pTsPacket);
	const bool ProcEcmPacket(const CTsPacket *pTsPacket);
	const bool ProcCatPacket(const CTsPacket *pTsPacket);
	const bool ProcEmmPacket(const CTsPacket *pTsPacket);

	void OnPmtUpdate(const CPmtTable &PmtTable);
	bool IsEpgData(WORD wPID);
	DWORD crc32(BYTE *head, BYTE *tail);
	void ir_cmdtx(void){
		if(m_usb == NULL || m_ir_cmd_num == 0)
			return;
		LONG cmd_len=0;
		u8	cmd[64];
		s32 i;
		s32 ir_wait = 600;
		for(i=0; i<m_ir_cmd_num; i++){
			cmd[cmd_len++]=CMD_IR_CODE;
			cmd[cmd_len++]=(u8)m_ir_cmd[i];
			cmd[cmd_len++]=(u8)(m_ir_cmd[i] >> 8);
			m_usb->xfer(m_outep, cmd, cmd_len);
			cmd_len=0;
			if(m_ir_cmd[i] == (0x04d8 + m_ir_base)) 
				ir_wait = 300;	//3digit
			Sleep(ir_wait);
			//IRo͒~
			cmd[cmd_len++]=CMD_IR_CODE;
			cmd[cmd_len++]=0;
			cmd[cmd_len++]=0;
			m_usb->xfer(m_outep, cmd, cmd_len);
			cmd_len=0;
			Sleep(100);
		}
	};

	struct TAG_PMTSET
	{
		WORD wPmtPID;
		WORD wPmtSvcNo;
		CPmtTable PmtTable;
	};
	struct TAG_ECMSET
	{
		WORD wEcmPID;
	};
	struct TAG_EMMSET
	{
		WORD eEmmPID;
	};
	CPatTable m_PatTable;
	vector<TAG_PMTSET> m_PmtList;
	vector<TAG_ECMSET> m_EcmList;
	vector<TAG_EMMSET> m_EmmList;
	WORD m_CatVersion;

	//CPatTable m_lastPatTable;
	vector<TAG_PMTSET> m_lastPmtList;
	time_t m_lastPatTime;

	DWORD m_dwInputPacketCount;
	DWORD m_dwOutputPacketCount;

	WORD m_wEcmSetIndex;

	int m_ServiceId;
	int m_SvcNo;
	int	m_ChChangeCount;
	WORD m_wPmtPID;

	cusb2 *m_usb;
	CCyUSBEndPoint *m_outep;
	u16 m_ir_cmd[16];
	s32 m_ir_cmd_num;
	u16 m_ir_base;

	time_t m_tChChange;
};

#endif // !defined(_TSDESCRAMBLER_H_)
